
const fac_bsc = require("nv-facutil-basic");
const _def    = require("./def");
const _err    = require("./err");
const _idcard = require("chinese-idcard");


const PROPS = [
  'sheet_id',           'seq',
  'oper',               'action',
  'reason',             'name',
  'phone',              'idcard',
  'attr',               'plate',
  'corp',               'corp_contact_name',
  'corp_contact_phone', 'material',
  'health',             'travel',
  'signature',          'all_files_ok'
]

class Data extends Array {
    constructor(sheet_id,seq,oper,action,reason,name,phone,idcard,attr,plate,corp,corp_contact_name,corp_contact_phone,material,health,travel,signature,all_files_ok) {
        super();
        super.push(
            sheet_id,seq,oper,action,reason,name,phone,idcard,attr,plate,corp,corp_contact_name,corp_contact_phone,material,health,travel,signature,all_files_ok
        );
    }
    ////

    get sheet_id()    {return(this[0])}
    set sheet_id(v)   {this[0]=v}


    get seq()    {return(this[1])}
    set seq(v)   {this[1]=v}


    get oper()    {return(this[2])}
    set oper(v)   {this[2]=v}


    get action()    {return(this[3])}
    set action(v)   {this[3]=v}


    get reason()    {return(this[4])}
    set reason(v)   {this[4]=v}


    get name()    {return(this[5])}
    set name(v)   {this[5]=v}


    get phone()    {return(this[6])}
    set phone(v)   {this[6]=v}


    get idcard()    {return(this[7])}
    set idcard(v)   {this[7]=v}


    get attr()    {return(this[8])}
    set attr(v)   {this[8]=v}


    get plate()    {return(this[9])}
    set plate(v)   {this[9]=v}


    get corp()    {return(this[10])}
    set corp(v)   {this[10]=v}


    get corp_contact_name()    {return(this[11])}
    set corp_contact_name(v)   {this[11]=v}


    get corp_contact_phone()    {return(this[12])}
    set corp_contact_phone(v)   {this[12]=v}


    get material()    {return(this[13])}
    set material(v)   {this[13]=v}


    get health()    {return(this[14])}
    set health(v)   {this[14]=v}


    get travel()    {return(this[15])}
    set travel(v)   {this[15]=v}


    get signature()    {return(this[16])}
    set signature(v)   {this[16]=v}


    get all_files_ok() {return(this[17])}
    set all_files_ok(v) {this[17]=v}
    ////
    dict() {
        let d = {}
        for(let i=0;i<PROPS.length;i++) {
              let k = PROPS[i];
              d[k]= this[i];
        }
        return(d)
    }
}
Data.PROPS = PROPS;



const CREAT_CFG = ()=>({
    oper:'',                           //后端自动填充
    action:'',                         //  
    reason:'',                         //
    name:'',
    phone:'',
    idcard:'',
    attr:'',                           
    plate:'',
    corp:'',
    corp_contact_name       : '',
    corp_contact_phone      : '',
    material:[],
    health:{type:"",id:""},
    travel:{type:"",id:""},
    signature:'',
})


const FRONT_CREAT_CFG = ()=>({
    action:'',                         //  
    reason:'',                         //
    name:'',
    phone:'',
    idcard:'',
    attr:'', 
    plate:'',
    corp:'',
    corp_contact_name       : '',
    corp_contact_phone      : '',
    material:[],
    health:{type:"",id:""},
    travel:{type:"",id:""},
    signature:'',
});


const is_valid_cuname = (cuname)=> fac_bsc.is_str(cuname) && cuname.length>0;

const PHONE_RGX = /[0-9\-]+/;
const is_valid_phone  = (phone) => fac_bsc.is_str(phone) && PHONE_RGX.test(phone) && phone.length>0;

const is_valid_idcard  = (id)=> {
    let s = id;
    if(!fac_bsc.is_str(s)) {
        return(false)
    } else if(s.length===18) {
        try {
            let d = _idcard.parse(s);
            if(
                d.province &&
                d.city     &&
                d.county   &&
                d.year     && 
                d.month    &&
                d.day      &&
                d.police   &&
                d.sex      &&
                d.sex_code !== undefined &&
                d.parity
            ){
                return(true) 
            } else {
                return(false)
            }
        } catch(err) {
            return(false)
        }
    } else {
        return(false)
    }
}

const is_valid_plate = (plate)=> fac_bsc.is_str(plate) && plate.length>0;

/*
const is_valid_img   = (img) =>true
const is_valid_imgs  = (imgs)=>imgs.every(img=>is_valid_img(img));
    ncfg.idcard_front_img      = {size:parseInt(ncfg.idcard_front_img.size)};
    ncfg.idcard_back_img       = {size:parseInt(ncfg.idcard_back_img.size)};
    ncfg.vehicle_lic_front_img = {size:parseInt(ncfg.vehicle_lic_front_img.size)};
    ncfg.vehicle_lic_back_img  = {size:parseInt(ncfg.vehicle_lic_back_img.size)};
    ncfg.contract_imgs         = ncfg.contract_imgs.map(img=>({size:parseInt(img.size)}));
    ncfg.videos                = ncfg.videos.map(img=>({size:parseInt(img.size)}));


    } else if(ncfg.contract_imgs<=0) {
        return([false,_err.contract_imgs_must_ge_1])
    } else if(ncfg.videos<=0) {
        return([false,_err.videos_must_ge_1])

    } else if(!is_valid_img(ncfg.idcard_front_img)) {
        return([false,_err.idcard_front_img_size_must_gt_0])
    } else if(!is_valid_img(ncfg.idcard_back_img)) {
        return([false,_err.idcard_back_img_size_must_gt_0])
    } else if(!is_valid_img(ncfg.vehicle_lic_front_img)) {
        return([false,_err.vehicle_lic_front_img_size_must_gt_0])
    } else if(!is_valid_img(ncfg.vehicle_lic_back_img)) {
        return([false,_err.vehicle_lic_back_img_size_must_gt_0])
    } else if(!is_valid_imgs(ncfg.contract_imgs)) {
        return([false,_err.each_size_of_contract_img_must_gt_0])
    } else if(!is_valid_imgs(ncfg.videos)) {
        return([false,_err.each_size_of_video_must_gt_0])
*/


const creat = (cfg=CREAT_CFG())=> {
    let ncfg = CREAT_CFG();
    fac_bsc.OASGN(ncfg,cfg);
    ////
    let data = new Data();
    if(!is_valid_cuname(ncfg.name)) {
        return([false,_err.cuname_cant_be_empty])
    } else if(!is_valid_phone(ncfg.phone)) {
        return([false,_err.phone_cant_be_empty_and_can_only_includes_digit_and_dash])
    } else if(!is_valid_idcard(ncfg.idcard)) {
        return([false,_err.invalid_idcard])
    } else if(!is_valid_plate(ncfg.plate)) {
        return([false,_err.invalid_plate])
    } else {
        data.sheet_id   = fac_bsc.creat_36_lower_id();
        data.seq        = 0;
        data.oper       = ncfg.oper;
        data.action     = _def.ACT_EN2CH.creat;
        data.reason     = ncfg.reason;
        data.name       = ncfg.name;
        data.phone      = String(ncfg.phone);
        data.idcard     = String(ncfg.idcard);
        data.attr       = String(ncfg.attr);
        data.plate      = String(ncfg.plate);
        data.corp       = String(ncfg.corp);
        data.corp_contact_name       = String(ncfg.corp_contact_name);
        data.corp_contact_phone       = String(ncfg.corp_contact_phone);
        ////---------------------------------------------------
        data.material                =  ncfg.material;
        data.health                  =  ncfg.health;
        data.travel                  =  nfcg.travel;
        data.signature               =  ncfg.signature;
        ////-----------------------------------------------------------
        data.all_files_ok          =  false;
        return([true,data])
    }
}

module.exports = {
    Data,
    is_valid_cuname,
    CREAT_CFG,
    creat,
    FRONT_CREAT_CFG,
}
